<template>
    <div class="slds-box slds-theme_default">
        <div class="slds-grid slds-wrap slds-gutters">
            <div class="slds-col slds-size_1-of-3">
                <div style="margin-left: 2em;">
                    <div class="slds-text-heading_large slds-p-top_x-large">Mandelbrot Set</div>
                    <div class="slds-text-heading_medium slds-p-top_medium">Formula: f(z) = z*z + c</div>
                    <div class="slds-p-top_large complex">
                        <div style="display: flex;">
                            <div class="slds-text-heading_medium">Complex Number C</div>
                            <lightning-helptext class="slds-m-left_xx-small" content="Complex number consists of two parts"></lightning-helptext>
                        </div>
                            <lightning-input name="a" type="number" label="Real Part" placeholder="a..." onchange={handleNumberAInput}></lightning-input>
                        <lightning-input name="b" type="number" label="Imaginary Part" placeholder="bi..." onchange={handleNumberBInput}></lightning-input>
                    </div>
                    <div>
                        <div style="display: flex;" class="slds-m-top_large">
                            <div class="slds-text-heading_medium">Color Scheme</div>
                            <lightning-helptext class="slds-m-left_xx-small" content="Inner fractal color"></lightning-helptext>
                        </div>
                        <lightning-input type="color" label="Select Color" value={color} onchange={handleColorChange}>
                        </lightning-input>
                    </div>
                    <div class="slds-m-top_large">
                        <button class="slds-button slds-button_outline-brand slds-m-right_medium" onclick={handleDownloadClick}>Download</button>
                        <button class="slds-button slds-button_brand" onclick={drawDefault}>Draw</button>
                    </div>
                </div>
            </div>
            <div class="slds-col slds-size_2-of-3">
                <div class="slds-p-top_x-large">
                    <template if:false={isLoaded}>
                        <lightning-spinner alternative-text="Loading..." variant="brand"></lightning-spinner>
                    </template>
                    <canvas></canvas>
                </div>
                <div class="slds-grid">
                    <div class="slds-col slds-size_11-of-12">
                        <lightning-button-group class="slds-m-top_large">
                            <lightning-button label="-" onclick={handleZoomOut}></lightning-button>
                            <lightning-button label="+" onclick={handleZoomIn}></lightning-button>
                        </lightning-button-group>
                    </div>
                    <div class="slds-col slds-size_1-of-12">
                        <button class="slds-button slds-button_icon slds-button_icon-inverse slds-float_right slds-m-top_large" onclick={handleModal}>
                            <lightning-icon class="slds-icon-text-light" icon-name="action:question_post_action" size="small" 
                                style="background-color: #f3f3f3" alternative-text="Help" title="Help">
                                <label>Help</label>
                            </lightning-icon>
                        </button>
                        <c-modal-window is-modal-open={isModalOpen} header-text="Help" body-text="On this tab you can draw a    Mandelbrot set (fractal). Enter the C constant and choose a color scheme." onclosemodal={handleModal}>
                        </c-modal-window>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>